From 95ee8ab77da6b76729beee6fc6ffccb07c9a2167 Mon Sep 17 00:00:00 2001
From: Andrew Kelley <andrew@ziglang.org>
Date: Mon, 21 Nov 2022 12:36:26 -0700
Subject: [PATCH 2/4] simplify outline atomics

 * Rely on libSystem when targeting macOS.
 * Make tools/gen_outline_atomics.zig more idiomatic.
 * Remove the CPU detection / auxval checking from compiler_rt. This
   functionality belongs in a different component. Zig's compiler_rt
   must not rely on constructors. Instead it will export a symbol for
   setting the value, and start code can detect and activate it.
 * Remove the separate logic for inline assembly when the target does or
   does not have lse support. `.inst` works in both cases.
---
 lib/compiler_rt.zig             |    8 +-
 lib/compiler_rt/lse_atomics.zig | 9678 +++----------------------------
 tools/gen_outline_atomics.zig   |  455 +-
 3 files changed, 875 insertions(+), 9266 deletions(-)

diff --git a/lib/compiler_rt.zig b/lib/compiler_rt.zig
index 98c9e2074b3..9487ac01e63 100644
--- a/lib/compiler_rt.zig
+++ b/lib/compiler_rt.zig
@@ -1,8 +1,14 @@
+const builtin = @import("builtin");
+
 pub const panic = @import("compiler_rt/common.zig").panic;
 
 comptime {
     _ = @import("compiler_rt/atomics.zig");
-    _ = @import("compiler_rt/lse_atomics.zig");
+
+    // macOS has these functions inside libSystem.
+    if (builtin.cpu.arch.isAARCH64() and !builtin.os.tag.isDarwin()) {
+        _ = @import("compiler_rt/lse_atomics.zig");
+    }
 
     _ = @import("compiler_rt/addf3.zig");
     _ = @import("compiler_rt/addhf3.zig");
